package solution;
import java.util.*;
import java.io.IOException;

import problem.*;
//import tester.Tester;
public class ProblemSolver {
    
    // ps is the problem we're trying to solve
    private static ProblemSpec ps;
    // solution is a list of every configuration after the initial config
    private static Stack<ArmConfig> solution;
    // We also have a RoboMover to move our robot around the world
    private static RoboMover mover;

    public static void main(String[] args) {
    	//First we initialise all our solution's class variables.
        ps = new ProblemSpec();
        solution = new Stack<>();
        //try to load the problem from command line
        if (args.length < 2) {
        	System.out.println("Usage: a1-3702 [test] [solution]");
        	return;
        }
        try {
            ps.loadProblem(args[0]);
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }

        mover = new RoboMover(ps);
        solution.add(ps.getInitialState());
        solution = mover.moveToNode(solution.peek(), ps.getGoalState());
        
        try {
            ps.setPath(solution);
            ps.saveSolution(args[1]);
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
}